
#ifndef AST_H
#define AST_H

#include "core.h"
#include "list.h"

#define var string
#define list List::list
#define Opt    Core::Opt

#define values <int>list
#define rule *(<int>list,stmt)
#define character <rule>list

prefix Ast {
  open Ast;

extern union stmt {
 *(<*(condition,stmt)>list,stmt) If;
 *(<int>Opt,string) Decision;
 *(var, <*(values,stmt)>list, stmt) Case;
}

extern union condition {
  *(var,int) Equals;
  <condition>list And;
  <condition>list Or;
}

}

#endif




